Doomsday Engine - Feature #1886

Use SDL 2 for window management, display modes, color correction, and keyboard/mouse/gamepad
input
2014-10-20 15:17 - skyjake

Status: In Progress Start date: 2014-10-20
Priority: Urgent % Done: 90%
Assignee: skyjake

Category: Redesign

Target version: 3.0

Description

SDL 2 has quite good support for low-level functionality that is essential to games. Particularly, it supports native input APIs like
Xlnput on Windows, for raw device events. Using SDL 2 instead of custom code and Qt for all these things (wm, video, input) should
improve robustness and reduce the maintenance burden.

In practice:

e SDL 2 should be linked to libgui and there should be a variant of GLWindow that creates an underlying SDL_Window.

¢ DisplayMode should be removed and replaced with SDL video functions.

¢ Qt's OpenGL API wrappers should still be usable with an SDL-created OpenGL context (after creating a QOpenGLContext
representing the previously created context).

Related issues:

Related to Feature #1229: Input plugins: generate events from connected contr... Rejected 2003-07-09
Related to Feature #1741: Upgrade to SDL 2 Closed 2014-03-27
Related to Bug #778: Gamepad usability issues Progressed 2007-06-07
Related to Bug #1042: [Windows] Alt key and console activation New 2012-05-15
Related to Bug #1041: [Windows] Pressing Alt/AltGr key confuses turning New 2012-05-15
Related to Feature #1758: Separate left/right modifier keys (Shift, Alt, etc.) New 2014-04-18
Related to Bug #2259: Mouse unusable on ArchLinux with Gnome / Wayland New 2017-07-23
History

#1 - 2014-10-20 15:17 - skyjake

- Related to Feature #1229: Input plugins: generate events from connected controllers added

#2 - 2014-10-20 15:17 - skyjake
- Related to Feature #1741: Upgrade to SDL 2 added

#3 - 2014-10-20 15:17 - skyjake
- Subject changed from Use SDL2 for keyboard, mouse, and joystick input to Use SDL 2 for keyboard, mouse, and joystick input

#4 - 2014-10-20 15:25 - skyjake
- Tags changed from Input to Input, Plugin

#5 - 2015-01-16 12:14 - skyjake
- Description updated

#6 - 2015-01-16 12:15 - skyjake
- Description updated

#7 - 2015-01-16 12:15 - skyjake
- Related to Bug #778: Gamepad usability issues added

#8 - 2015-03-13 08:58 - skyjake
- Related to Bug #1042: [Windows] Alt key and console activation added
#9 - 2015-03-13 08:58 - skyjake
- Related to Bug #1041: [Windows] Pressing Alt/AltGr key confuses turning added

#10 - 2015-04-22 04:31 - danij
- Priority changed from Normal to High

#11 - 2015-04-22 05:08 - danij

- Assignee set to danij

#12 - 2015-05-03 17:03 - skyjake
- Target version changed from 42 to 2.0 — Home Ul & Packages

#13 - 2015-09-13 13:45 - skyjake

Joysticks/gamepads are already being accessed via SDL2.

#14 - 2015-11-03 09:20 - skyjake
- Subject changed from Use SDL 2 for keyboard, mouse, and joystick input to Input plugins that use SDL 2 for keyboard, mouse, and joystick input

#15 - 2015-11-03 09:20 - skyjake

- Subject changed from Input plugins that use SDL 2 for keyboard, mouse, and joystick input to Input plugin that use SDL 2 for keyboard, mouse, and
Joystick input

#16 - 2015-11-03 09:21 - skyjake

- Subject changed from Input plugin that use SDL 2 for keyboard, mouse, and joystick input to Input plugin that uses SDL 2 for keyboard, mouse, and
Joystick input

#17 - 2016-03-27 08:15 - skyjake

- Target version changed from 2.0 — Home Ul & Packages to Input and game controllers

#18 - 2017-07-05 08:29 - skyjake
- Assignee changed from danij to skyjake
- Priority changed from High to Urgent

- Target version changed from Input and game controllers to 2.1 (Late 2018)

#19 - 2017-07-05 08:30 - skyjake

- Subject changed from Input plugin that uses SDL 2 for keyboard, mouse, and joystick input to Input plugin that uses SDL 2 for keyboard and mouse
input

#20 - 2017-07-05 08:32 - skyjake

When the game grabs key/mouse input, events should be received via SDL so that the appropriate low-level APIs are used.

Ul event handling can still be done via Qt as currently.

#21 - 2017-07-11 19:11 - skyjake

- Subject changed from Input plugin that uses SDL 2 for keyboard and mouse input to Use SDL 2 for window management, display modes, color
correction, and keyboard/mouse/gamepad input

- Description updated
- Category changed from Enhancement to Redesign

- Target version changed from 2.1 (Late 2018) to Rendering

#22 - 2017-07-11 19:13 - skyjake
- Related to Feature #1758: Separate left/right modifier keys (Shift, Alt, etc.) added

#23 - 2017-07-24 08:22 - skyjake
- Related to Bug #2259: Mouse unusable on ArchLinux with Gnome / Wayland added

#24 - 2018-07-29 16:41 - skyjake
- Target version changed from Rendering to 3.0

#25 - 2018-07-29 16:41 - skyjake
- Status changed from New to In Progress

- % Done changed from 0 to 50
#26 - 2018-07-29 16:43 - skyjake

I've been working on this recently, in addition to removing dependencies on Qt in the main executables. Currently debugging through a number of
regressions. At least keyboard input should be much improved thanks to raw input modes.

#27 - 2018-11-05 19:31 - skyjake
- Target version changed from 3.0 to 2.2 (2019)

#28 - 2019-06-28 06:58 - skyjake
- % Done changed from 50 to 90

#29 - 2019-10-14 10:23 - skyjake
- Target version changed from 2.2 (2019) to 3.0
